Index: uspace/app/tester/mm/common.c
===================================================================
--- uspace/app/tester/mm/common.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/tester/mm/common.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -371,5 +371,5 @@
 	
 	/* Free the memory */
-	errno_t ret = as_area_destroy(area->addr);
+	int ret = as_area_destroy(area->addr);
 	if (ret != EOK)
 		error_flag = true;
Index: uspace/app/tester/mm/mapping1.c
===================================================================
--- uspace/app/tester/mm/mapping1.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/tester/mm/mapping1.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -30,5 +30,4 @@
 #include <stdlib.h>
 #include <stddef.h>
-#include <str_error.h>
 #include <as.h>
 #include <errno.h>
@@ -66,5 +65,5 @@
     verify_mapping((area), (page_count), (expected_rc), #expected_rc)
 
-static bool verify_mapping(void *area, int page_count, errno_t expected_rc,
+static bool verify_mapping(void *area, int page_count, int expected_rc,
     const char *expected_rc_str)
 {
@@ -73,8 +72,8 @@
 	for (i = 0; i < page_count; i++) {
 		void *page_start = ((char *) area) + PAGE_SIZE * i;
-		errno_t rc = as_get_physical_mapping(page_start, NULL);
+		int rc = as_get_physical_mapping(page_start, NULL);
 		if (rc != expected_rc) {
-			TPRINTF("as_get_physical_mapping() = %s != %s\n",
-			    str_error_name(rc), str_error_name(expected_rc));
+			TPRINTF("as_get_physical_mapping() = %d != %d\n",
+			    rc, expected_rc);
 			return false;
 		}
@@ -85,5 +84,5 @@
 const char *test_mapping1(void)
 {
-	errno_t rc;
+	int rc;
 	
 	size_t buffer1_len = BUFFER1_PAGES * PAGE_SIZE;
Index: uspace/app/tester/mm/pager1.c
===================================================================
--- uspace/app/tester/mm/pager1.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/tester/mm/pager1.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -45,11 +45,11 @@
 {
 	size_t nwr;
-	errno_t rc;
+	int rc;
 
 	TPRINTF("Creating temporary file...\n");
 
-	rc = vfs_lookup_open(TEST_FILE, WALK_REGULAR | WALK_MAY_CREATE,
-	    MODE_READ | MODE_WRITE, &fd);
-	if (rc != EOK)
+	fd = vfs_lookup_open(TEST_FILE, WALK_REGULAR | WALK_MAY_CREATE,
+	    MODE_READ | MODE_WRITE);
+	if (fd < 0)
 		return NULL;
 	(void) vfs_unlink_path(TEST_FILE);
Index: uspace/app/tester/print/print5.c
===================================================================
--- uspace/app/tester/print/print5.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/tester/print/print5.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -37,5 +37,5 @@
  *
  */
-#define _HELENOS_NVERIFY_PRINTF
+#define NVERIFY_PRINTF
 
 #include <stdio.h>
Index: uspace/app/tester/thread/thread1.c
===================================================================
--- uspace/app/tester/thread/thread1.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/tester/thread/thread1.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -32,5 +32,4 @@
 
 #include <atomic.h>
-#include <errno.h>
 #include <thread.h>
 #include <stdio.h>
@@ -62,5 +61,5 @@
 	TPRINTF("Creating threads");
 	for (i = 0; i < THREADS; i++) {
-		if (thread_create(threadtest, NULL, "threadtest", NULL) != EOK) {
+		if (thread_create(threadtest, NULL, "threadtest", NULL) < 0) {
 			TPRINTF("\nCould not create thread %u\n", i);
 			break;
Index: uspace/app/tester/vfs/vfs1.c
===================================================================
--- uspace/app/tester/vfs/vfs1.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/tester/vfs/vfs1.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -31,5 +31,4 @@
 #include <stdlib.h>
 #include <stddef.h>
-#include <str_error.h>
 #include <str.h>
 #include <vfs/vfs.h>
@@ -69,17 +68,16 @@
 {
 	aoff64_t pos = 0;
-	errno_t rc;
+	int rc;
 
 	rc = vfs_link_path(TEST_DIRECTORY, KIND_DIRECTORY, NULL);
 	if (rc != EOK) {
-		TPRINTF("rc=%s\n", str_error_name(rc));
+		TPRINTF("rc=%d\n", rc);
 		return "vfs_link_path() failed";
 	}
 	TPRINTF("Created directory %s\n", TEST_DIRECTORY);
 	
-	int fd0;
-	rc = vfs_lookup_open(TEST_FILE, WALK_REGULAR | WALK_MAY_CREATE,
-	    MODE_READ | MODE_WRITE, &fd0);
-	if (rc != EOK)
+	int fd0 = vfs_lookup_open(TEST_FILE, WALK_REGULAR | WALK_MAY_CREATE,
+	    MODE_READ | MODE_WRITE);
+	if (fd0 < 0)
 		return "vfs_lookup_open() failed";
 	TPRINTF("Created file %s (fd=%d)\n", TEST_FILE, fd0);
@@ -97,5 +95,5 @@
 	TPRINTF("read..\n");
 	while ((rc = vfs_read(fd0, &pos, buf, BUF_SIZE, &cnt))) {
-		TPRINTF("read returns rc = %s, cnt = %zu\n", str_error_name(rc), cnt);
+		TPRINTF("read returns rc = %d, cnt = %zu\n", rc, cnt);
 		if (rc != EOK)
 			return "read() failed";
Index: uspace/app/testread/testread.c
===================================================================
--- uspace/app/testread/testread.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/testread/testread.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -58,5 +58,4 @@
 #include <time.h>
 #include <offset.h>
-#include <str.h>
 
 #define NAME	"testread"
Index: uspace/app/testwrit/testwrit.c
===================================================================
--- uspace/app/testwrit/testwrit.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/testwrit/testwrit.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -33,5 +33,4 @@
 #include <stdio.h>
 #include <stddef.h>
-#include <str.h>
 
 #define BUF_SIZE  1024
Index: uspace/app/tetris/scores.c
===================================================================
--- uspace/app/tetris/scores.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/tetris/scores.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -205,5 +205,5 @@
 }
 
-errno_t loadscores(void)
+int loadscores(void)
 {
 	FILE *f;
Index: uspace/app/tetris/scores.h
===================================================================
--- uspace/app/tetris/scores.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/tetris/scores.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -72,5 +72,5 @@
 extern void initscores(void);
 extern void insertscore(int score, int level);
-extern errno_t loadscores(void);
+extern int loadscores(void);
 extern void savescores(void);
 
Index: uspace/app/tetris/screen.c
===================================================================
--- uspace/app/tetris/screen.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/tetris/screen.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -138,5 +138,5 @@
 winsize_t winsize;
 
-static errno_t get_display_size(winsize_t *ws)
+static int get_display_size(winsize_t *ws)
 {
 	return console_get_size(console, &ws->ws_col, &ws->ws_row);
@@ -146,7 +146,7 @@
 {
 	sysarg_t ccap;
-	errno_t rc = console_get_color_cap(console, &ccap);
-	
-	if (rc != EOK)
+	int rc = console_get_color_cap(console, &ccap);
+	
+	if (rc != 0)
 		return false;
 	
Index: uspace/app/tetris/tetris.c
===================================================================
--- uspace/app/tetris/tetris.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/tetris/tetris.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -156,7 +156,7 @@
 const struct shape *randshape(void)
 {
-	const struct shape *tmp = &shapes[rand() % 7];
+	const struct shape *tmp = &shapes[random() % 7];
 	int i;
-	int j = rand() % 4;
+	int j = random() % 4;
 	
 	for (i = 0; i < j; i++)
@@ -171,5 +171,5 @@
 	
 	gettimeofday(&tv, NULL);
-	srand(tv.tv_sec + tv.tv_usec / 100000);
+	srandom(tv.tv_sec + tv.tv_usec / 100000);
 }
 
Index: uspace/app/top/screen.c
===================================================================
--- uspace/app/top/screen.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/top/screen.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -45,5 +45,4 @@
 #include <inttypes.h>
 #include <macros.h>
-#include <str.h>
 #include "screen.h"
 #include "top.h"
Index: uspace/app/top/screen.h
===================================================================
--- uspace/app/top/screen.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/top/screen.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -45,5 +45,5 @@
 extern void print_data(data_t *);
 extern void show_warning(const char *, ...)
-    _HELENOS_PRINTF_ATTRIBUTE(1, 2);
+    PRINTF_ATTRIBUTE(1, 2);
 
 extern int tgetchar(unsigned int);
Index: uspace/app/top/top.c
===================================================================
--- uspace/app/top/top.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/top/top.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -43,5 +43,4 @@
 #include <errno.h>
 #include <gsort.h>
-#include <str.h>
 #include "screen.h"
 #include "top.h"
Index: uspace/app/trace/Makefile
===================================================================
--- uspace/app/trace/Makefile	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/trace/Makefile	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,5 +36,6 @@
 	ipcp.c \
 	ipc_desc.c \
-	proto.c
+	proto.c \
+	errors.c
 
 include $(USPACE_PREFIX)/Makefile.common
Index: uspace/app/trace/errors.c
===================================================================
--- uspace/app/trace/errors.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
+++ uspace/app/trace/errors.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -0,0 +1,61 @@
+/*
+ * Copyright (c) 2008 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup trace
+ * @{
+ */
+/** @file
+ */
+
+#include <errno.h>
+#include "errors.h"
+
+const err_desc_t err_desc[] = {
+	[-EOK]		= { "EOK",		"No error" },
+	[-ENOENT]	= { "ENOENT",		"No such entry" },
+	[-ENOMEM]	= { "ENOMEM",		"Not enough memory" },
+	[-ELIMIT]	= { "ELIMIT",		"Limit exceeded" },
+	[-EREFUSED]	= { "EREFUSED",		"Connection refused" },
+
+	[-EFORWARD]	= { "EFORWARD",		"Forward error" },
+	[-EPERM]	= { "EPERM",		"Permission denied" },
+	[-EHANGUP]	= { "EHANGUP",		"Answerbox closed connection" },
+	[-EEXIST]	= { "EEXIST",		"Entry already exists" },
+	[-EBADMEM]	= { "EBADMEM",		"Bad memory pointer" },
+
+	[-ENOTSUP]	= { "ENOTSUP",		"Not supported" },
+	[-EADDRNOTAVAIL] = { "EADDRNOTAVAIL", 	"Address not available." },
+	[-ETIMEOUT]	= { "ETIMEOUT",		"Timeout expired" },
+	[-EINVAL]	= { "EINVAL",		"Invalid value" },
+	[-EBUSY]	= { "EBUSY",		"Resource is busy" },
+
+	[-EOVERFLOW]	= { "EOVERFLOW",	"The result does not fit its size." }
+};
+
+/** @}
+ */
Index: uspace/app/trace/errors.h
===================================================================
--- uspace/app/trace/errors.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
+++ uspace/app/trace/errors.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -0,0 +1,48 @@
+/*
+ * Copyright (c) 2008 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup trace
+ * @{
+ */
+/** @file
+ */
+
+#ifndef ERRORS_H_
+#define ERRORS_H_
+
+typedef struct {
+	const char *name;  /**< Error value name (Exx) */
+	const char *desc;  /**< Error description */
+} err_desc_t;
+
+extern const err_desc_t err_desc[];
+
+#endif
+
+/** @}
+ */
Index: uspace/app/trace/ipcp.c
===================================================================
--- uspace/app/trace/ipcp.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/trace/ipcp.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -35,5 +35,4 @@
 #include <stdio.h>
 #include <stdlib.h>
-#include <str_error.h>
 #include <inttypes.h>
 #include <adt/hash_table.h>
@@ -250,5 +249,5 @@
 	sysarg_t method;
 	sysarg_t service;
-	errno_t retval;
+	sysarg_t retval;
 	proto_t *proto;
 	int cphone;
@@ -265,7 +264,7 @@
 	
 	if ((display_mask & DM_IPC) != 0) {
-		printf("Response to %d: retval=%s, args = (%" PRIun ", "
+		printf("Response to %d: retval=%" PRIdn ", args = (%" PRIun ", "
 		    "%" PRIun ", %" PRIun ", %" PRIun ", %" PRIun ")\n",
-		    hash, str_error_name(retval), IPC_GET_ARG1(*answer),
+		    hash, retval, IPC_GET_ARG1(*answer),
 		    IPC_GET_ARG2(*answer), IPC_GET_ARG3(*answer),
 		    IPC_GET_ARG4(*answer), IPC_GET_ARG5(*answer));
@@ -281,5 +280,5 @@
 			if (oper->rv_type != V_VOID) {
 				putchar(' ');
-				val_print((sysarg_t) retval, oper->rv_type);
+				val_print(retval, oper->rv_type);
 			}
 			
@@ -345,8 +344,8 @@
 }
 
-void ipcp_hangup(int phone, errno_t rc)
+void ipcp_hangup(int phone, int rc)
 {
 	if ((display_mask & DM_SYSTEM) != 0) {
-		printf("Hang phone %d up -> %s\n", phone, str_error_name(rc));
+		printf("Hang phone %d up -> %d\n", phone, rc);
 		ipcp_connection_clear(phone);
 	}
Index: uspace/app/trace/ipcp.h
===================================================================
--- uspace/app/trace/ipcp.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/trace/ipcp.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -44,5 +44,5 @@
 void ipcp_call_sync(int phone, ipc_call_t *call, ipc_call_t *answer);
 void ipcp_call_in(ipc_call_t *call, ipc_callid_t hash);
-void ipcp_hangup(int phone, errno_t rc);
+void ipcp_hangup(int phone, int rc);
 
 void ipcp_connection_set(int phone, int server, proto_t *proto);
Index: uspace/app/trace/trace.c
===================================================================
--- uspace/app/trace/trace.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/trace/trace.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -63,4 +63,5 @@
 #include "syscalls.h"
 #include "ipcp.h"
+#include "errors.h"
 #include "trace.h"
 
@@ -93,6 +94,6 @@
 display_mask_t display_mask;
 
-static errno_t program_run_fibril(void *arg);
-static errno_t cev_fibril(void *arg);
+static int program_run_fibril(void *arg);
+static int cev_fibril(void *arg);
 
 static void program_run(void)
@@ -122,7 +123,7 @@
 }
 
-static errno_t program_run_fibril(void *arg)
-{
-	errno_t rc;
+static int program_run_fibril(void *arg)
+{
+	int rc;
 
 	/*
@@ -131,5 +132,5 @@
 	 */
 	rc = loader_run(task_ldr);
-	if (rc != EOK) {
+	if (rc != 0) {
 		printf("Error running program\n");
 		exit(1);
@@ -143,5 +144,5 @@
 
 
-static errno_t connect_task(task_id_t task_id)
+static int connect_task(task_id_t task_id)
 {
 	async_sess_t *ksess = async_connect_kbox(task_id);
@@ -161,13 +162,13 @@
 	}
 	
-	errno_t rc = udebug_begin(ksess);
-	if (rc != EOK) {
-		printf("udebug_begin() -> %s\n", str_error_name(rc));
+	int rc = udebug_begin(ksess);
+	if (rc < 0) {
+		printf("udebug_begin() -> %d\n", rc);
 		return rc;
 	}
 	
 	rc = udebug_set_evmask(ksess, UDEBUG_EM_ALL);
-	if (rc != EOK) {
-		printf("udebug_set_evmask(0x%x) -> %s\n ", UDEBUG_EM_ALL, str_error_name(rc));
+	if (rc < 0) {
+		printf("udebug_set_evmask(0x%x) -> %d\n ", UDEBUG_EM_ALL, rc);
 		return rc;
 	}
@@ -177,7 +178,7 @@
 }
 
-static errno_t get_thread_list(void)
-{
-	errno_t rc;
+static int get_thread_list(void)
+{
+	int rc;
 	size_t tb_copied;
 	size_t tb_needed;
@@ -186,6 +187,6 @@
 	rc = udebug_thread_read(sess, thread_hash_buf,
 		THBUF_SIZE*sizeof(unsigned), &tb_copied, &tb_needed);
-	if (rc != EOK) {
-		printf("udebug_thread_read() -> %s\n", str_error_name(rc));
+	if (rc < 0) {
+		printf("udebug_thread_read() -> %d\n", rc);
 		return rc;
 	}
@@ -225,6 +226,6 @@
 		if (sval >= -15 && sval <= 0) {
 			printf("%ld %s (%s)", sval,
-			    str_error_name((errno_t) sval),
-			    str_error((errno_t) sval));
+			    err_desc[-sval].name,
+			    err_desc[-sval].desc);
 		} else {
 			printf("%ld", sval);
@@ -234,6 +235,6 @@
 		if (sval >= -15 && sval < 0) {
 			printf("%ld %s (%s)", sval,
-			    str_error_name((errno_t) sval),
-			    str_error((errno_t) sval));
+			    err_desc[-sval].name,
+			    err_desc[-sval].desc);
 		} else {
 			printf("%ld", sval);
@@ -279,10 +280,10 @@
 }
 
-static void sc_ipc_call_async_fast(sysarg_t *sc_args, errno_t sc_rc)
+static void sc_ipc_call_async_fast(sysarg_t *sc_args, sysarg_t sc_rc)
 {
 	ipc_call_t call;
 	sysarg_t phoneid;
 	
-	if (sc_rc != EOK)
+	if (sc_rc != (sysarg_t) EOK)
 		return;
 
@@ -296,13 +297,13 @@
 	IPC_SET_ARG5(call, 0);
 
-	ipcp_call_out(phoneid, &call, 0);
-}
-
-static void sc_ipc_call_async_slow(sysarg_t *sc_args, errno_t sc_rc)
+	ipcp_call_out(phoneid, &call, sc_rc);
+}
+
+static void sc_ipc_call_async_slow(sysarg_t *sc_args, sysarg_t sc_rc)
 {
 	ipc_call_t call;
-	errno_t rc;
-
-	if (sc_rc != EOK)
+	int rc;
+
+	if (sc_rc != (sysarg_t) EOK)
 		return;
 
@@ -310,6 +311,6 @@
 	rc = udebug_mem_read(sess, &call.args, sc_args[1], sizeof(call.args));
 
-	if (rc == EOK) {
-		ipcp_call_out(sc_args[0], &call, 0);
+	if (rc >= 0) {
+		ipcp_call_out(sc_args[0], &call, sc_rc);
 	}
 }
@@ -318,5 +319,5 @@
 {
 	ipc_call_t call;
-	errno_t rc;
+	int rc;
 
 	if (sc_rc == 0) return;
@@ -325,5 +326,5 @@
 	rc = udebug_mem_read(sess, &call, sc_args[0], sizeof(call));
 	
-	if (rc == EOK)
+	if (rc >= 0)
 		ipcp_call_in(&call, sc_rc);
 }
@@ -333,10 +334,10 @@
 {
 	sysarg_t sc_args[6];
-	errno_t rc;
+	int rc;
 
 	/* Read syscall arguments */
 	rc = udebug_args_read(sess, thread_hash, sc_args);
 
-	if (rc != EOK) {
+	if (rc < 0) {
 		printf("error\n");
 		return;
@@ -361,5 +362,5 @@
 	sysarg_t sc_args[6];
 	int rv_type;
-	errno_t rc;
+	int rc;
 
 	/* Read syscall arguments */
@@ -368,5 +369,5 @@
 //	printf("[%d] ", thread_id);
 
-	if (rc != EOK) {
+	if (rc < 0) {
 		printf("error\n");
 		return;
@@ -384,8 +385,8 @@
 	switch (sc_id) {
 	case SYS_IPC_CALL_ASYNC_FAST:
-		sc_ipc_call_async_fast(sc_args, (errno_t) sc_rc);
+		sc_ipc_call_async_fast(sc_args, sc_rc);
 		break;
 	case SYS_IPC_CALL_ASYNC_SLOW:
-		sc_ipc_call_async_slow(sc_args, (errno_t) sc_rc);
+		sc_ipc_call_async_slow(sc_args, sc_rc);
 		break;
 	case SYS_IPC_WAIT:
@@ -403,7 +404,7 @@
 }
 
-static errno_t trace_loop(void *thread_hash_arg)
-{
-	errno_t rc;
+static int trace_loop(void *thread_hash_arg)
+{
+	int rc;
 	unsigned ev_type;
 	uintptr_t thread_hash;
@@ -445,5 +446,5 @@
 		}
 
-		if (rc == EOK) {
+		if (rc >= 0) {
 			switch (ev_type) {
 			case UDEBUG_EVENT_SYSCALL_B:
@@ -498,5 +499,5 @@
 {
 	loader_t *ldr;
-	errno_t rc;
+	int rc;
 
 	/* Spawn a program loader */
@@ -566,5 +567,5 @@
 }
 
-static errno_t cev_fibril(void *arg)
+static int cev_fibril(void *arg)
 {
 	cons_event_t event;
@@ -581,5 +582,5 @@
 		
 		if (!console_get_event(console, &event))
-			return EINVAL;
+			return -1;
 		
 		if (event.type == CEV_KEY) {
@@ -598,11 +599,11 @@
 	bool done;
 	int i;
-	errno_t rc;
+	int rc;
 
 	ipcp_init();
 
 	rc = get_thread_list();
-	if (rc != EOK) {
-		printf("Failed to get thread list (%s)\n", str_error(rc));
+	if (rc < 0) {
+		printf("Failed to get thread list (error %d)\n", rc);
 		return;
 	}
@@ -643,5 +644,5 @@
 			rc = udebug_stop(sess, thash);
 			if (rc != EOK)
-				printf("Error: stop -> %s\n", str_error_name(rc));
+				printf("Error: stop -> %d\n", rc);
 			break;
 		case KC_R:
@@ -844,5 +845,5 @@
 int main(int argc, char *argv[])
 {
-	errno_t rc;
+	int rc;
 	task_exit_t texit;
 	int retval;
@@ -859,5 +860,5 @@
 
 	rc = connect_task(task_id);
-	if (rc != EOK) {
+	if (rc < 0) {
 		printf("Failed connecting to task %" PRIu64 ".\n", task_id);
 		return 1;
Index: uspace/app/untar/main.c
===================================================================
--- uspace/app/untar/main.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/untar/main.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -44,5 +44,5 @@
 }
 
-static errno_t skip_blocks(FILE *tarfile, size_t valid_data_size)
+static int skip_blocks(FILE *tarfile, size_t valid_data_size)
 {
 	size_t blocks_to_read = get_block_count(valid_data_size);
@@ -58,5 +58,5 @@
 }
 
-static errno_t handle_normal_file(const tar_header_t *header, FILE *tarfile)
+static int handle_normal_file(const tar_header_t *header, FILE *tarfile)
 {
 	// FIXME: create the directory first
@@ -69,5 +69,5 @@
 	}
 
-	errno_t rc = EOK;
+	int rc = EOK;
 	size_t bytes_remaining = header->size;
 	size_t blocks = get_block_count(bytes_remaining);
@@ -101,7 +101,7 @@
 }
 
-static errno_t handle_directory(const tar_header_t *header, FILE *tarfile)
+static int handle_directory(const tar_header_t *header, FILE *tarfile)
 {
-	errno_t rc;
+	int rc;
 
 	rc = vfs_link_path(header->filename, KIND_DIRECTORY, NULL);
@@ -140,5 +140,5 @@
 			break;
 		}
-		errno_t rc = tar_header_parse(&header, &header_raw);
+		int rc = tar_header_parse(&header, &header_raw);
 		if (rc == EEMPTY) {
 			continue;
Index: uspace/app/untar/tar.c
===================================================================
--- uspace/app/untar/tar.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/untar/tar.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -67,7 +67,7 @@
 }
 
-errno_t tar_header_parse(tar_header_t *parsed, const tar_header_raw_t *raw)
+int tar_header_parse(tar_header_t *parsed, const tar_header_raw_t *raw)
 {
-	errno_t rc;
+	int rc;
 
 	if (str_length(raw->filename) == 0) {
Index: uspace/app/untar/tar.h
===================================================================
--- uspace/app/untar/tar.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/untar/tar.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -70,5 +70,5 @@
 
 
-extern errno_t tar_header_parse(tar_header_t *, const tar_header_raw_t *);
+extern int tar_header_parse(tar_header_t *, const tar_header_raw_t *);
 extern tar_type_t tar_type_parse(const char);
 extern const char *tar_type_str(tar_type_t);
Index: uspace/app/usbinfo/hid.c
===================================================================
--- uspace/app/usbinfo/hid.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/usbinfo/hid.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -136,5 +136,5 @@
 
 	size_t actual_report_size;
-	errno_t rc = usb_request_get_descriptor(ctrl_pipe,
+	int rc = usb_request_get_descriptor(ctrl_pipe,
 	    USB_REQUEST_TYPE_STANDARD, USB_REQUEST_RECIPIENT_INTERFACE,
 	    USB_DESCTYPE_HID_REPORT, 0, iface_no,
Index: uspace/app/usbinfo/info.c
===================================================================
--- uspace/app/usbinfo/info.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/usbinfo/info.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -313,5 +313,5 @@
 	l18_win_locales_t *langs;
 	size_t langs_count;
-	errno_t rc = usb_request_get_supported_languages(
+	int rc = usb_request_get_supported_languages(
 	    usb_device_get_default_pipe(usb_dev), &langs, &langs_count);
 	if (rc != EOK) {
@@ -362,5 +362,5 @@
 void dump_status(usb_device_t *usb_dev)
 {
-	errno_t rc;
+	int rc;
 	uint16_t status = 0;
 
Index: uspace/app/usbinfo/list.c
===================================================================
--- uspace/app/usbinfo/list.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/usbinfo/list.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -45,5 +45,4 @@
 #include <loc.h>
 #include <usb_iface.h>
-#include <str.h>
 
 #include "usbinfo.h"
@@ -54,5 +53,5 @@
 {
 	char path[MAX_PATH_LENGTH];
-	errno_t rc = devman_fun_get_path(handle, path, MAX_PATH_LENGTH);
+	int rc = devman_fun_get_path(handle, path, MAX_PATH_LENGTH);
 	if (rc != EOK) {
 		printf(NAME "Failed to get path for device %"PRIun"\n", handle);
@@ -65,5 +64,5 @@
 {
 	devman_handle_t hc_handle = 0;
-	errno_t rc = devman_fun_sid_to_handle(svc, &hc_handle);
+	int rc = devman_fun_sid_to_handle(svc, &hc_handle);
 	if (rc != EOK) {
 		printf(NAME ": Error resolving handle of HC with SID %"
@@ -134,5 +133,5 @@
 	service_id_t *svcs;
 	size_t count;
-	errno_t rc;
+	int rc;
 
 	rc = loc_category_get_id(USB_HC_CATEGORY, &usbhc_cat, 0);
Index: uspace/app/usbinfo/main.c
===================================================================
--- uspace/app/usbinfo/main.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/usbinfo/main.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -198,5 +198,5 @@
 		/* The initialization is here only to make compiler happy. */
 		devman_handle_t handle = 0;
-		errno_t rc = usb_resolve_device_handle(devpath, &handle);
+		int rc = usb_resolve_device_handle(devpath, &handle);
 		if (rc != EOK) {
 			fprintf(stderr, NAME ": device `%s' not found "
Index: uspace/app/usbinfo/usbinfo.h
===================================================================
--- uspace/app/usbinfo/usbinfo.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/usbinfo/usbinfo.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -56,5 +56,5 @@
 extern void dump_descriptor_tree(uint8_t *, size_t);
 
-static inline void internal_error(errno_t err)
+static inline void internal_error(int err)
 {
 	fprintf(stderr, NAME ": internal error (%s).\n", str_error(err));
Index: uspace/app/viewer/viewer.c
===================================================================
--- uspace/app/viewer/viewer.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/viewer/viewer.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -44,5 +44,4 @@
 #include <codec/tga.h>
 #include <task.h>
-#include <str.h>
 
 #define NAME  "viewer"
@@ -110,11 +109,10 @@
 static bool img_load(const char *fname, surface_t **p_local_surface)
 {
-	int fd;
-	errno_t rc = vfs_lookup_open(fname, WALK_REGULAR, MODE_READ, &fd);
-	if (rc != EOK)
-		return false;
-	
-	vfs_stat_t stat;
-	rc = vfs_stat(fd, &stat);
+	int fd = vfs_lookup_open(fname, WALK_REGULAR, MODE_READ);
+	if (fd < 0)
+		return false;
+	
+	struct stat stat;
+	int rc = vfs_stat(fd, &stat);
 	if (rc != EOK) {
 		vfs_put(fd);
Index: uspace/app/vlaunch/vlaunch.c
===================================================================
--- uspace/app/vlaunch/vlaunch.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/vlaunch/vlaunch.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -66,5 +66,5 @@
 	task_id_t id;
 	task_wait_t wait;
-	errno_t rc = task_spawnl(&id, &wait, app, app, winreg, NULL);
+	int rc = task_spawnl(&id, &wait, app, app, winreg, NULL);
 	if (rc != EOK) {
 		printf("%s: Error spawning %s %s (%s)\n", NAME, app,
Index: uspace/app/vuhid/device.c
===================================================================
--- uspace/app/vuhid/device.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/vuhid/device.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -41,5 +41,5 @@
 #include <usb/classes/classes.h>
 
-static errno_t on_data_from_device(usbvirt_device_t *dev,
+static int on_data_from_device(usbvirt_device_t *dev,
     usb_endpoint_t ep, usb_transfer_type_t tr_type,
     void *data, size_t data_size, size_t *actual_size)
@@ -58,5 +58,5 @@
 }
 
-static errno_t on_data_to_device(usbvirt_device_t *dev,
+static int on_data_to_device(usbvirt_device_t *dev,
     usb_endpoint_t ep, usb_transfer_type_t tr_type,
     const void *data, size_t data_size)
@@ -75,5 +75,5 @@
 }
 
-static errno_t interface_life_fibril(void *arg)
+static int interface_life_fibril(void *arg)
 {
 	vuhid_interface_t *iface = arg;
@@ -109,5 +109,5 @@
 }
 
-errno_t add_interface_by_id(vuhid_interface_t **interfaces, const char *id,
+int add_interface_by_id(vuhid_interface_t **interfaces, const char *id,
     usbvirt_device_t *dev)
 {
@@ -161,5 +161,5 @@
 
 	/* From now on, in case of errors, we goto to error_leave */
-	errno_t rc;
+	int rc;
 
 	/*
Index: uspace/app/vuhid/hids/bootkbd.c
===================================================================
--- uspace/app/vuhid/hids/bootkbd.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/vuhid/hids/bootkbd.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -101,5 +101,5 @@
 };
 
-static errno_t on_data_out(vuhid_interface_t *iface,
+static int on_data_out(vuhid_interface_t *iface,
     const void *buffer, size_t buffer_size)
 {
Index: uspace/app/vuhid/life.c
===================================================================
--- uspace/app/vuhid/life.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/vuhid/life.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -56,5 +56,5 @@
 
 
-errno_t interface_live_on_data_in(vuhid_interface_t *iface,
+int interface_live_on_data_in(vuhid_interface_t *iface,
     void *buffer, size_t buffer_size, size_t *act_buffer_size)
 {
Index: uspace/app/vuhid/main.c
===================================================================
--- uspace/app/vuhid/main.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/app/vuhid/main.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -216,5 +216,5 @@
 	/* Determine which interfaces to initialize. */
 	for (int i = optind; i < argc; i++) {
-		errno_t rc = add_interface_by_id(available_hid_interfaces, argv[i],
+		int rc = add_interface_by_id(available_hid_interfaces, argv[i],
 		    &hid_dev);
 		if (rc != EOK) {
@@ -234,5 +234,5 @@
 	}
 
-	const errno_t rc = usbvirt_device_plug(&hid_dev, controller);
+	const int rc = usbvirt_device_plug(&hid_dev, controller);
 	if (rc != EOK) {
 		printf("Unable to start communication with VHCD `%s': %s.\n",
